diff -urN Original_4.4.4_r1/frameworks/base/media/java/android/media/MediaPlayer.java AndroidSource/frameworks/base/media/java/android/media/MediaPlayer.java
--- Original_4.4.4_r1/frameworks/base/media/java/android/media/MediaPlayer.java	2016-01-29 15:12:31.439488000 +0900
+++ AndroidSource/frameworks/base/media/java/android/media/MediaPlayer.java	2016-09-26 18:37:06.839666097 +0900
@@ -993,120 +1197,1315 @@
     }
 
     private native void _setDataSource(
-        String path, String[] keys, String[] values)
-        throws IOException, IllegalArgumentException, SecurityException, IllegalStateException;
+            String path, String[] keys, String[] values)
+            throws IOException, IllegalArgumentException, SecurityException, IllegalStateException;
 
     /**
-     * Sets the data source (FileDescriptor) to use. It is the caller's responsibility
-     * to close the file descriptor. It is safe to do so as soon as this call returns.
-     *
+     * Sets the data source (FileDescriptor) to use. It is the caller's
+     * responsibility to close the file descriptor. It is safe to do so as soon
+     * as this call returns.
+     * 
      * @param fd the FileDescriptor for the file you want to play
      * @throws IllegalStateException if it is called in an invalid state
      */
     public void setDataSource(FileDescriptor fd)
             throws IOException, IllegalArgumentException, IllegalStateException {
+        Log.d(TAG, "666 - hc");
+
         // intentionally less than LONG_MAX
         setDataSource(fd, 0, 0x7ffffffffffffffL);
     }
 
     /**
-     * Sets the data source (FileDescriptor) to use.  The FileDescriptor must be
-     * seekable (N.B. a LocalSocket is not seekable). It is the caller's responsibility
-     * to close the file descriptor. It is safe to do so as soon as this call returns.
-     *
+     * Sets the data source (FileDescriptor) to use. The FileDescriptor must be
+     * seekable (N.B. a LocalSocket is not seekable). It is the caller's
+     * responsibility to close the file descriptor. It is safe to do so as soon
+     * as this call returns.
+     * 
      * @param fd the FileDescriptor for the file you want to play
-     * @param offset the offset into the file where the data to be played starts, in bytes
+     * @param offset the offset into the file where the data to be played
+     *            starts, in bytes
      * @param length the length in bytes of the data to be played
      * @throws IllegalStateException if it is called in an invalid state
      */
     public void setDataSource(FileDescriptor fd, long offset, long length)
             throws IOException, IllegalArgumentException, IllegalStateException {
+
+        Log.d(TAG, "Video set data source (start)");
+        FileDescriptor fd1 = fd;
+        Log.d(TAG, "777 - hc");
+//        Log.d(TAG, "777 - hc, " + fd1.valid() + " and fd? : " + fd2.valid() + "  " + fd1.equals(fd2));
+        Log.d("VideoLatency", "Video loading");
+        Log.d("AudioLatency", "Audio loading");
+
+        IRemoteService mService = IRemoteService.Stub
+                .asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+//        try {
+            
+            if (isAudio) {
+                new mAudioGo().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, mContent);
+            }
+            
+            // video
+            else if(!isAudio){
+                Log.d(TAG, "video in, getting remote system service");
+
+                Log.d(TAG, "video and audio thread before start");
+                //init video and request surface provider
+                new mLets().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, "");
+                int vport = 31200;
+                
+                ///////////
+                
+                
+                ArrayList<AppendingObjectOutputStream> vList = new ArrayList<AppendingObjectOutputStream>();
+                ArrayList<AppendingObjectOutputStream> aList = new ArrayList<AppendingObjectOutputStream>();
+                Log.d(TAG, "done with setting server");
+                
+                try {
+//                    List<String> serverIPs = mService.getServerIPs();
+                    int numberOfPlayers = mService.getVideoPlayers();
+                    for(int i = 0; i < numberOfPlayers;i++){
+                        
+                        try {
+                            vList.add(new mVideoServerAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, vport).get());
+                            
+                            aList.add(new mAudioServerAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, ++vport).get());
+                            
+                            vport++;
+//                            vList.add(getOutputStream(vport));
+//                            
+                        } catch (InterruptedException e) {
+                            // TODO Auto-generated catch block
+                            e.printStackTrace();
+                        } catch (ExecutionException e) {
+                            // TODO Auto-generated catch block
+                            e.printStackTrace();
+                        }
+//                        vport = vport+2;
+//                        new mVideoFeederAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, mContent, vport);
+//                        new mAudioFeederAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, mContent, ++vport);
+//                        vport++;
+                        
+                    }
+                    Log.d(TAG, "vList: " + vList.toString());
+                    Log.d(TAG, "aList: " + aList.toString());
+                new mVideoGoAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, mContent, vList);
+                new mAudioGoAsync().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, mContent, aList);
+//                new mVideoGoAsync().execute(mContent);
+                    
+                } catch (RemoteException e1) {
+                    // TODO Auto-generated catch block
+                    e1.printStackTrace();
+                }
+                
+                Log.d(TAG, "video and audio thread after start");
+
+                Log.d(TAG, "media player exiting");
+            }
+            
+//        } 
+//        catch (RemoteException e) {
+//            // TODO Auto-generated catch block
+//            e.printStackTrace();
+//        }
+
+        Log.d(TAG, "original setdatasource");
+        // original
         disableProxyListener();
         _setDataSource(fd, offset, length);
+        Log.d(TAG, "original setdatasource done");
     }
 
+    
     private native void _setDataSource(FileDescriptor fd, long offset, long length)
             throws IOException, IllegalArgumentException, IllegalStateException;
 
+
+    public void closing_all_serversockets(){
+        ServerSocket ss;
+        try {
+            ss = new ServerSocket();
+            ss.setReuseAddress(true);
+            for(int i=0;i<22320;i++){
+                ss.bind(new InetSocketAddress(i));
+                ss.close();
+            }
+        } catch (IOException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+
+    }
+    
+    private class mAudioGo extends AsyncTask<Object, Void, Void>{
+        
+        MediaExtractor mExtractor;
+        IRemoteService mService = IRemoteService.Stub
+                .asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+        @Override
+        protected Void doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+            try {
+                
+                Uri uri = (Uri) params[0];
+                AssetFileDescriptor fd = null;
+                try {
+                    ContentResolver resolver = mContext.getContentResolver();
+                    fd = resolver.openAssetFileDescriptor(uri, "r");
+                } catch (FileNotFoundException e1) {
+                    // TODO Auto-generated catch block
+                    e1.printStackTrace();
+                }
+
+                try {
+                    mExtractor = new MediaExtractor();
+                    mExtractor.setDataSource(fd.getFileDescriptor());
+                } catch (IOException e) {
+                    // TODO Auto-generated catch block
+                    e.printStackTrace();
+                }
+                
+                MediaFormat format = new MediaFormat();
+                String mime = "";
+                int sampleRate = 0, channels = 0;
+                long duration = 0L;
+
+                try {
+                    format = mExtractor.getTrackFormat(0);
+                    mime = format.getString(MediaFormat.KEY_MIME);
+                    sampleRate = format.getInteger(MediaFormat.KEY_SAMPLE_RATE);
+                    channels = format.getInteger(MediaFormat.KEY_CHANNEL_COUNT);
+                    // if duration is 0, we are probably playing a live stream
+                    duration = format.getLong(MediaFormat.KEY_DURATION);
+                } catch (Exception e) {
+                    Log.e(TAG, "Reading format parameters exception:" + e.getMessage());
+                }
+                mExtractor.selectTrack(0);
+
+                // check the format variables
+                Log.d(TAG, "Track info: mime:" + mime + " sampleRate:" + sampleRate
+                        + " channels:" + channels + " duration:" + duration);
+                // mService =
+                // IRemoteRequestHandler.Stub.asInterface(ServiceManager
+                // .getService(Context.REMOTE_SERVICE));
+
+                ArrayList<Object> parameters = new ArrayList<Object>();
+                parameters.add(0, mime);
+                parameters.add(1, sampleRate);
+                parameters.add(2, channels);
+                parameters.add(3, duration);
+                
+                RemoteRequest mRequest = new RemoteRequest("RemoteMusic",
+                        "SettingCodec", parameters);
+                // try {
+//                mService.sendRequest(mRequest);
+                
+                mService.sendAllrequest(mRequest);
+                // } catch (RemoteException e) {
+                // TODO Auto-generated catch block
+                // e.printStackTrace();
+                // } finally {
+//                parameters.clear();
+                // }
+
+                // feeding
+                ByteBuffer tmp_byteBuffer = null;
+                int sampleSize = 0;
+                boolean flag = true;
+                
+                int forTest = 0;
+                
+                tmp_byteBuffer = ByteBuffer.allocate(1500);
+                // try {
+                while (flag) {
+                    tmp_byteBuffer.clear();
+                    sampleSize = mExtractor.readSampleData(tmp_byteBuffer, 0);
+                    byte[] to_send = new byte[sampleSize];
+                    for (int i = 0; i < to_send.length; i++) {
+                        to_send[i] = tmp_byteBuffer.get(i);
+                    }
+                    long presentationTime = mExtractor.getSampleTime();
+
+                    
+                    
+                    mService.sendAllMusic(sampleSize, to_send, presentationTime);
+//                    mService.sendMusicData(sampleSize, to_send, presentationTime);
+                    if (sampleSize <= 0) {
+                        // this is where music file is ended
+                    } else {
+                        mExtractor.advance();
+                        }
+                    // Log.d(TAG, "File: i sent" + Arrays.toString(to_send));
+                    // Thread.sleep(1000);
+                    forTest++;
+                    if(forTest == 5){
+                        flag = false;
+                    }
+                }
+                // } catch (RemoteException e) {
+                // TODO Auto-generated catch block
+                // e.printStackTrace();
+                // }
+                // Stopping music
+                mRequest = new RemoteRequest("StopMusic", null, null);
+                // try {
+                mService.sendRequest(mRequest);
+                // } catch (RemoteException e) {
+                // TODO Auto-generated catch block
+                // e.printStackTrace();
+                // } finally {
+                parameters.clear();
+                // }
+            } catch (Exception e) {
+                e.printStackTrace();
+            }
+            
+            return null;
+        }
+        
+    }
+    
+    private class mLets extends AsyncTask<Object, Void, Void>{
+
+        IRemoteService mService = IRemoteService.Stub
+                .asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+        @Override
+        protected Void doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+            int vport = 31200;
+//            List<String> serverIPs = null;
+//            try {
+//                serverIPs = mService.getServerIPs();
+//            } catch (RemoteException e1) {
+//                // TODO Auto-generated catch block
+//                e1.printStackTrace();
+//            }
+            try{
+                mService.sendVideoSignal(vport);
+            } catch(Exception e){
+                e.printStackTrace();
+            }
+            
+            
+//            for(int i = 0; i < mService.get.size();i++){
+//                ArrayList<Object> vInfo = new ArrayList<Object>();
+//                vInfo.clear();
+//                vInfo.add(0, serverIPs.get(i));
+//                vInfo.add(1, vport);
+//                
+//                RemoteRequest mRequest = new RemoteRequest("video_streaming", "get_surface", vInfo);
+//                Log.d(TAG, "made request to , " + serverIPs.get(i) + " with port :" + vport);
+//                try {
+//                    mService.sendRequest(mRequest);
+//                } catch (RemoteException e) {
+//                    // TODO Auto-generated catch block
+//                    e.printStackTrace();
+////                    continue;
+//                }
+//                vport = vport + 2;
+//            }
+            return null;
+        }
+        
+    }
+    
+    private class mVideoServerAsync extends AsyncTask<Object, Void, AppendingObjectOutputStream>{
+
+        private MediaExtractor mExtractor;
+        AppendingObjectOutputStream output;
+        String path_url = "";
+
+        @Override
+        protected AppendingObjectOutputStream doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+
+            int port = (Integer) params[0];
+
+            ServerSocket serverSocket = null;
+            try {
+                serverSocket = new ServerSocket();
+                serverSocket.setReuseAddress(true);
+                serverSocket.bind(new InetSocketAddress(port));
+//                mExtractor = new MediaExtractor();
+//                mExtractor.setDataSource(fd.getFileDescriptor());
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            try {
+                Log.d(TAG, "Video: the server is ready to feed!! " + port);
+                Socket socket = serverSocket.accept();
+                Log.d(TAG, "Video: the client of streaming video is in!! " + port);
+                // Socket s = new Socket(InetAddress.getLocalHost(), vport);
+                OutputStream os = socket.getOutputStream();
+                ObjectOutputStream toos = new ObjectOutputStream(os);
+                output = new AppendingObjectOutputStream(os);
+            } catch (IOException e){
+                e.printStackTrace();
+            }
+
+            return output;
+        }
+    }
+    
+
+    private class mVideoGoAsync extends AsyncTask<Object, Void, Void>{
+
+        private MediaExtractor mExtractor;
+        AppendingObjectOutputStream output;
+        int port = 22300;
+        String path_url = "";
+
+        @Override
+        protected Void doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+
+            Uri uri = (Uri) params[0];
+            AssetFileDescriptor fd = null;
+            try {
+                ContentResolver resolver = mContext.getContentResolver();
+                fd = resolver.openAssetFileDescriptor(uri, "r");
+            } catch (FileNotFoundException e1) {
+                // TODO Auto-generated catch block
+                e1.printStackTrace();
+            }
+
+            try {
+                mExtractor = new MediaExtractor();
+                mExtractor.setDataSource(fd.getFileDescriptor());
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            try{
+                // Media format
+                ArrayList<AppendingObjectOutputStream> outputList = (ArrayList<AppendingObjectOutputStream>) params[1];
+                for (int i = 0; i < mExtractor.getTrackCount(); i++) {
+                    MediaFormat format = mExtractor.getTrackFormat(i);
+                    String mime = format.getString(MediaFormat.KEY_MIME);
+                    int width = 0, height = 0;
+                    if (mime.startsWith("video/")) {
+                        mExtractor.selectTrack(i);
+                        try {
+                            width = format.getInteger(MediaFormat.KEY_WIDTH);
+                            height = format.getInteger(MediaFormat.KEY_HEIGHT);
+                            // if duration is 0, we are probably playing a live stream
+
+                            Log.d(TAG, "Track info: mime:" + mime
+                                    + " sampleRate:" + width + " channels:"
+                                    + height);
+                        } catch (Exception e) {
+                            Log.e(TAG, "Reading format parameters exception:"
+                                    + e.getMessage());
+                            // don't exit, tolerate this error, we'll fail later if this is critical
+                        }
+                        
+                        for(int j=0;j<outputList.size();j++){
+                            outputList.get(j).writeUTF("connect");
+//                            output.writeUTF("connect");
+                            outputList.get(j).flush();
+                        }
+                        
+                        Log.d(TAG, "Async go: output test is done");
+                        
+                        // getting csd-0
+                        ByteBuffer header_sps = format.getByteBuffer("csd-0");
+                        byte[] b_h_sps = new byte[header_sps.capacity()];
+                        header_sps.get(b_h_sps);
+                        // getting csd-1
+                        ByteBuffer header_pps = format.getByteBuffer("csd-1");
+                        byte[] b_h_pps = new byte[header_pps.capacity()];
+                        header_pps.get(b_h_pps);
+
+                        vData vdata = new vData();
+                        vdata.setMediaFormat(mime, width, height, b_h_sps, b_h_pps);
+                        for(int j=0;j<outputList.size();j++){
+                            outputList.get(j).writeObject(vdata);
+                            outputList.get(j).flush();
+                        }
+                        
+                        Log.d(TAG, "client: done sending format");
+
+                        break;
+                    }
+                }
+
+                // feeding start
+                boolean isEOS = true;
+
+                ByteBuffer byteBuffer = ByteBuffer.allocate(300000);
+
+                while (isEOS) {
+                    int sampleSize = 0;
+                    try {
+                        sampleSize = mExtractor.readSampleData(byteBuffer, 0);
+                        // Log.d(TAG, j + "  " + byteBuffer.toString());
+                        // byteBuffer.get(to_send);
+                    } catch (IllegalArgumentException e) {
+                        e.printStackTrace();
+                    }
+                    if (sampleSize < 0) {
+                        isEOS = false;
+                        break;
+                    }
+                    byte[] to_send = new byte[sampleSize];
+
+                    for (int i = 0; i < sampleSize; i++) {
+                        to_send[i] = byteBuffer.get(i);
+                    }
+
+                    // Log.d(TAG, to_send.length + ", " + byteBuffer.limit());
+                    // Log.d(TAG, "The sample size is " + String.valueOf(sampleSize));
+                    long presentationTime = mExtractor.getSampleTime();
+
+                    vData vdata = new vData(sampleSize, to_send, presentationTime);
+
+                    for(int j=0;j<outputList.size();j++){
+                        try{
+                            outputList.get(j).writeObject(vdata);
+                            outputList.get(j).flush();
+                        } catch (Exception e){
+                            Log.d("VideoStreaming", "Exception when sending");
+                        }
+                    }
+//                    Log.d(TAG, "sent this much:  " + sampleSize);
+//                    output.writeObject(vdata);
+
+                    mExtractor.advance();
+                }
+
+                mExtractor.release();
+                //                socket.close();
+                //                serverSocket.close();
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            return null;
+        }
+    }
+    
+    
+    private class mAudioServerAsync extends AsyncTask<Object, Void, AppendingObjectOutputStream>{
+
+        MediaExtractor mExtractor;
+        private AppendingObjectOutputStream output;
+        String path_url = null;
+        
+        @Override
+        protected AppendingObjectOutputStream doInBackground(Object... params) {
+
+            int port = (Integer) params[0];
+
+            ServerSocket serverSocket = null;
+
+            try {
+                serverSocket = new ServerSocket();
+                serverSocket.setReuseAddress(true);
+                serverSocket.bind(new InetSocketAddress(port));
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            try {
+                Log.d(TAG, "Audio: the server is ready to feed!! "+port);
+                Socket socket = serverSocket.accept();
+                Log.d(TAG, "Audio: the client of streaming video is in!! "+port);
+                // Socket s = new Socket(InetAddress.getLocalHost(), vport);
+                OutputStream os = socket.getOutputStream();
+                ObjectOutputStream toos = new ObjectOutputStream(os);
+                output = new AppendingObjectOutputStream(os);
+            } catch (IOException e){
+                e.printStackTrace();
+            }
+
+            return output;
+            
+        }
+    }
+    
+    private class mAudioGoAsync extends AsyncTask<Object, Void, Void>{
+
+        private MediaExtractor mExtractor;
+        AppendingObjectOutputStream output;
+        int port = 22300;
+        String path_url = "";
+
+        @Override
+        protected Void doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+
+            Uri uri = (Uri) params[0];
+            AssetFileDescriptor fd = null;
+            try {
+                ContentResolver resolver = mContext.getContentResolver();
+                fd = resolver.openAssetFileDescriptor(uri, "r");
+            } catch (FileNotFoundException e1) {
+                // TODO Auto-generated catch block
+                e1.printStackTrace();
+            }
+
+            try {
+                mExtractor = new MediaExtractor();
+                mExtractor.setDataSource(fd.getFileDescriptor());
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            int sampleRate = 0, channels = 0, bitrate = 0;
+            long duration = 0;
+            
+            try{
+                // Media format
+                ArrayList<AppendingObjectOutputStream> outputList = (ArrayList<AppendingObjectOutputStream>) params[1];
+                for (int i = 0; i < mExtractor.getTrackCount(); i++) {
+                    MediaFormat format = mExtractor.getTrackFormat(i);
+                    String mime = format.getString(MediaFormat.KEY_MIME);
+                    if (mime.startsWith("audio/")) {
+                        mExtractor.selectTrack(i);
+                        try {
+                            mime = format.getString(MediaFormat.KEY_MIME);
+                            sampleRate = format.getInteger(MediaFormat.KEY_SAMPLE_RATE);
+                            channels = format.getInteger(MediaFormat.KEY_CHANNEL_COUNT);
+                            // if duration is 0, we are probably playing a live stream
+                            duration = format.getLong(MediaFormat.KEY_DURATION);
+                            // getting csd-0
+                            ByteBuffer header_sps = format.getByteBuffer("csd-0");
+                            byte[] b_h_sps = new byte[header_sps.capacity()];
+                            header_sps.get(b_h_sps);
+                            
+                            for(int j=0;j<outputList.size();j++){
+                                outputList.get(j).writeUTF("connect");
+                                outputList.get(j).flush();
+                            }
+                            
+                            SdPackage s = new SdPackage(mime, bitrate, channels,
+                                    sampleRate, duration, b_h_sps);
+                            for(int j=0;j<outputList.size();j++){
+                                outputList.get(j).writeObject(s);
+                                outputList.get(j).flush();
+                            }
+                            
+                        } catch (Exception e) {
+                            Log.e(TAG, "Reading format parameters exception:"
+                                    + e.getMessage());
+                            // don't exit, tolerate this error, we'll fail later if this is critical
+                        }
+                        
+                        Log.d(TAG, "Audio Async go: output test is done");
+                                                
+                        Log.d(TAG, "client: done sending format");
+
+                        break;
+                    }
+                }
+
+                // feeding start
+                boolean isEOS = true;
+
+                ByteBuffer byteBuffer = ByteBuffer.allocate(2000);
+
+                while (isEOS) {
+                    int sampleSize = 0;
+                    try {
+                        sampleSize = mExtractor.readSampleData(byteBuffer, 0);
+                    } catch (IllegalArgumentException e) {
+                        e.printStackTrace();
+                    }
+                    if (sampleSize < 0) {
+                        isEOS = false;
+                        break;
+                    }
+                    byte[] to_send = new byte[sampleSize];
+
+                    for (int i = 0; i < sampleSize; i++) {
+                        to_send[i] = byteBuffer.get(i);
+                    }
+
+                    // Log.d(TAG, to_send.length + ", " + byteBuffer.limit());
+                    // Log.d(TAG, "The sample size is " + String.valueOf(sampleSize));
+                    long presentationTime = mExtractor.getSampleTime();
+
+                    SdPackage s = new SdPackage(sampleSize, to_send, presentationTime);
+                    
+                    for(int j=0;j<outputList.size();j++){
+                        outputList.get(j).writeObject(s);
+                        outputList.get(j).flush();
+                    }
+//                    Log.d(TAG, "sent this much:  " + sampleSize);
+//                    output.writeObject(vdata);
+
+                    mExtractor.advance();
+                }
+
+                mExtractor.release();
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+
+            return null;
+        }
+    }
+    
+    
+    
+    private class mVideoFeederAsync extends AsyncTask<Object, Void, AppendingObjectOutputStream>{
+
+        private MediaExtractor mExtractor;
+        AppendingObjectOutputStream output;
+        int port = 22300;
+        String path_url = "";
+
+        @Override
+        protected AppendingObjectOutputStream doInBackground(Object... params) {
+            // TODO Auto-generated method stub
+            try{
+                Uri uri = (Uri) params[0];
+                AssetFileDescriptor fd = null;
+                try {
+                    ContentResolver resolver = mContext.getContentResolver();
+                    fd = resolver.openAssetFileDescriptor(uri, "r");
+                } catch (FileNotFoundException e1) {
+                    // TODO Auto-generated catch block
+                    e1.printStackTrace();
+                }
+
+                //            FileDescriptor fd = (FileDescriptor) params[0];
+                this.port = (Integer) params[1];
+
+                ServerSocket serverSocket = null;
+                try {
+                    serverSocket = new ServerSocket();
+                    serverSocket.setReuseAddress(true);
+                    serverSocket.bind(new InetSocketAddress(port));
+                    mExtractor = new MediaExtractor();
+                    mExtractor.setDataSource(fd.getFileDescriptor());
+                } catch (IOException e) {
+                    // TODO Auto-generated catch block
+                    e.printStackTrace();
+                }
+
+                try {
+                    Log.d(TAG, "Video: the server is ready to feed!!");
+                    Socket socket = serverSocket.accept();
+                    socket.setTcpNoDelay(true);
+                    Log.d(TAG, "Video: the client of streaming video is in!!");
+                    // Socket s = new Socket(InetAddress.getLocalHost(), vport);
+                    OutputStream os = socket.getOutputStream();
+                    ObjectOutputStream toos = new ObjectOutputStream(os);
+                    output = new AppendingObjectOutputStream(os);
+                } catch (IOException e){
+                    e.printStackTrace();
+                }
+
+                // Media format
+                for (int i = 0; i < mExtractor.getTrackCount(); i++) {
+                    MediaFormat format = mExtractor.getTrackFormat(i);
+                    String mime = format.getString(MediaFormat.KEY_MIME);
+                    int width = 0, height = 0;
+                    if (mime.startsWith("video/")) {
+                        mExtractor.selectTrack(i);
+                        try {
+                            width = format.getInteger(MediaFormat.KEY_WIDTH);
+                            height = format.getInteger(MediaFormat.KEY_HEIGHT);
+                            // if duration is 0, we are probably playing a live
+                            // stream
+
+                            Log.d(TAG, "Track info: mime:" + mime
+                                    + " sampleRate:" + width + " channels:"
+                                    + height);
+                        } catch (Exception e) {
+                            Log.e(TAG, "Reading format parameters exception:"
+                                    + e.getMessage());
+                            // don't exit, tolerate this error, we'll fail later
+                            // if this is critical
+                        }
+
+
+                        output.writeUTF("connect");
+                        output.flush();
+
+
+                        Log.d(TAG, "client: connect? ");
+
+                        // getting csd-0
+                        ByteBuffer header_sps = format.getByteBuffer("csd-0");
+                        byte[] b_h_sps = new byte[header_sps.capacity()];
+                        header_sps.get(b_h_sps);
+                        // getting csd-1
+                        ByteBuffer header_pps = format.getByteBuffer("csd-1");
+                        byte[] b_h_pps = new byte[header_pps.capacity()];
+                        header_pps.get(b_h_pps);
+
+                        vData vdata = new vData();
+                        vdata.setMediaFormat(mime, width, height, b_h_sps,
+                                b_h_pps);
+
+                        output.writeObject(vdata);
+                        output.flush();
+
+
+                        Log.d(TAG, "client: done sending format");
+
+                        break;
+                    }
+                }
+
+                // feeding start
+                boolean isEOS = true;
+
+                ByteBuffer byteBuffer = ByteBuffer.allocate(250000);
+
+                while (isEOS) {
+                    int sampleSize = 0;
+                    try {
+                        sampleSize = mExtractor.readSampleData(byteBuffer, 0);
+                        // Log.d(TAG, j + "  " + byteBuffer.toString());
+                        // byteBuffer.get(to_send);
+                    } catch (IllegalArgumentException e) {
+                        e.printStackTrace();
+                    }
+                    if (sampleSize < 0) {
+                        isEOS = false;
+                        break;
+                    }
+                    byte[] to_send = new byte[sampleSize];
+
+                    for (int i = 0; i < sampleSize; i++) {
+                        to_send[i] = byteBuffer.get(i);
+                    }
+
+                    // Log.d(TAG, to_send.length + ", " + byteBuffer.limit());
+                    // Log.d(TAG,
+                    // "The sample size is " + String.valueOf(sampleSize));
+                    long presentationTime = mExtractor.getSampleTime();
+
+                    vData vdata = new vData(sampleSize, to_send,
+                            presentationTime);
+
+                    output.writeObject(vdata);
+                    output.flush();
+
+                                      Log.d(TAG, "sampleSize at giving " + sampleSize + "");
+                    // if (sampleSize < 0) {
+                    // break;
+                    // } else {
+                    mExtractor.advance();
+                    // }
+                }
+
+
+
+                try {
+                    mExtractor.release();
+                    //              socket.close();
+                    serverSocket.close();
+                } catch (IOException e) {
+                    // TODO Auto-generated catch block
+                    e.printStackTrace();
+                }
+            } catch (IOException ioe){
+                ioe.printStackTrace();
+            }
+
+
+            return output;
+        }       
+    }
+    
+    
+    private class mAudioFeederAsync extends AsyncTask<Object, Void, AppendingObjectOutputStream>{
+
+        MediaExtractor mExtractor;
+        private AppendingObjectOutputStream oos;
+        private int port = 4439;
+        String path_url = null;
+        
+        @Override
+        protected AppendingObjectOutputStream doInBackground(Object... params) {
+            Log.d("AAAAA", "good to go");
+            // TODO Auto-generated method stub
+            Uri uri = (Uri) params[0];
+            AssetFileDescriptor fd = null;
+            try {
+                ContentResolver resolver = mContext.getContentResolver();
+                fd = resolver.openAssetFileDescriptor(uri, "r");
+            } catch (FileNotFoundException e1) {
+                // TODO Auto-generated catch block
+                e1.printStackTrace();
+            }
+
+//            FileDescriptor fd = (FileDescriptor) params[0];
+            this.port = (Integer) params[1];
+            MediaFormat format = null;
+            String mime = "";
+            int sampleRate = 0, channels = 0, bitrate = 0;
+            long duration = 0;
+            ServerSocket serverSocket = null;
+            
+            
+            try {
+                serverSocket = new ServerSocket();
+                serverSocket.setReuseAddress(true);
+                serverSocket.bind(new InetSocketAddress(this.port));
+                mExtractor = new MediaExtractor();
+                mExtractor.setDataSource(fd.getFileDescriptor());
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+            
+            try {
+                // serverSocket = new ServerSocket(aport);
+                Socket socket = serverSocket.accept();
+                // Socket socket = new Socket(InetAddress.getLocalHost(),
+                // aport);
+                Log.d(TAG, "Audio: client has connected");
+
+                OutputStream out = socket.getOutputStream();
+                ObjectOutputStream oo = new ObjectOutputStream(out);
+                InputStream in = socket.getInputStream();
+                ObjectInputStream ois = new ObjectInputStream(in);
+
+                oo.writeUTF("Hello");
+                oo.flush();
+                
+                oos = new AppendingObjectOutputStream(out);
+                
+                
+                // format setting
+                try {
+                    format = mExtractor.getTrackFormat(1);
+                    mime = format.getString(MediaFormat.KEY_MIME);
+                    sampleRate = format.getInteger(MediaFormat.KEY_SAMPLE_RATE);
+                    channels = format.getInteger(MediaFormat.KEY_CHANNEL_COUNT);
+                    // if duration is 0, we are probably playing a live stream
+                    duration = format.getLong(MediaFormat.KEY_DURATION);
+                    // getting csd-0
+                    ByteBuffer header_sps = format.getByteBuffer("csd-0");
+                    byte[] b_h_sps = new byte[header_sps.capacity()];
+                    header_sps.get(b_h_sps);
+
+                    // sending format meta-information from here
+                    SdPackage s = new SdPackage(mime, bitrate, channels,
+                            sampleRate, duration, b_h_sps);
+                    oos.writeObject(s);
+                    oos.flush();
+                } catch (IOException ioe) {
+                    ioe.printStackTrace();
+                }
+
+                Log.d(TAG, "feeder, Audio Track info: " + format.toString());
+                mExtractor.selectTrack(1);
+
+                ByteBuffer tmp_byteBuffer = ByteBuffer.allocate(2000);
+                int sampleSize = 0;
+                boolean flag = true;
+                while (flag) {
+                    sampleSize = mExtractor.readSampleData(tmp_byteBuffer, 0);
+
+                    if (sampleSize > 0) {
+                        byte[] to_send = new byte[sampleSize];
+                        for (int i = 0; i < sampleSize; i++) {
+                            to_send[i] = tmp_byteBuffer.get(i);
+                        }
+
+                        long presentationTime = mExtractor.getSampleTime();
+
+                        SdPackage sdp = new SdPackage(sampleSize, to_send,
+                                presentationTime);
+                        oos.writeObject(sdp);
+//                        oos.flush();
+                    }
+                    if (sampleSize < 0) {
+                        flag = false;
+                    } else {
+                        mExtractor.advance();
+                    }
+                }
+                
+                ois.close();
+                serverSocket.close();
+                socket.close();
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+            return null;
+            
+        }
+    }
+    
+    
+    private class mVideoFeeder extends Thread {
+        private MediaExtractor mExtractor;
+        AppendingObjectOutputStream output;
+        int vport = 22300;
+        String path_url = "";
+
+        mVideoFeeder(FileDescriptor fd , int port) {
+            vport = port;
+
+             mExtractor = new MediaExtractor();
+             try {
+             mExtractor.setDataSource(fd);
+             } catch (IOException e) {
+             // TODO Auto-generated catch block
+             e.printStackTrace();
+             }
+        }
+
+        mVideoFeeder(String path, int port) {
+            vport = port;
+            path_url = path;
+        }
+
+        @Override
+        public void run() {
+            try {
+
+//                mExtractor = new MediaExtractor();
+//                mExtractor.setDataSource(fd1);
+
+                ServerSocket serverSocket = new ServerSocket();
+                serverSocket.setReuseAddress(true);
+                serverSocket.bind(new InetSocketAddress(vport));
+                Log.d(TAG, "the server is ready to feed!!");
+                Socket socket = serverSocket.accept();
+                Log.d(TAG, "the client of streaming video is in!!");
+                // Socket s = new Socket(InetAddress.getLocalHost(), vport);
+                OutputStream os = socket.getOutputStream();
+                ObjectOutputStream toos = new ObjectOutputStream(os);
+                output = new AppendingObjectOutputStream(os);
+
+                // Media format
+                for (int i = 0; i < mExtractor.getTrackCount(); i++) {
+                    MediaFormat format = mExtractor.getTrackFormat(i);
+                    String mime = format.getString(MediaFormat.KEY_MIME);
+                    int width = 0, height = 0;
+                    if (mime.startsWith("video/")) {
+                        mExtractor.selectTrack(i);
+                        try {
+                            width = format.getInteger(MediaFormat.KEY_WIDTH);
+                            height = format.getInteger(MediaFormat.KEY_HEIGHT);
+                            // if duration is 0, we are probably playing a live
+                            // stream
+
+                            Log.d(TAG, "Track info: mime:" + mime
+                                    + " sampleRate:" + width + " channels:"
+                                    + height);
+                        } catch (Exception e) {
+                            Log.e(TAG, "Reading format parameters exception:"
+                                    + e.getMessage());
+                            // don't exit, tolerate this error, we'll fail later
+                            // if this is critical
+                        }
+
+                        // toos.writeUTF("connect!");
+                        // toos.flush();
+                        output.writeUTF("connect");
+                        output.flush();
+                        Log.d(TAG, "client: connect? ");
+
+                        // getting csd-0
+                        ByteBuffer header_sps = format.getByteBuffer("csd-0");
+                        byte[] b_h_sps = new byte[header_sps.capacity()];
+                        header_sps.get(b_h_sps);
+                        // getting csd-1
+                        ByteBuffer header_pps = format.getByteBuffer("csd-1");
+                        byte[] b_h_pps = new byte[header_pps.capacity()];
+                        header_pps.get(b_h_pps);
+
+                        vData vdata = new vData();
+                        vdata.setMediaFormat(mime, width, height, b_h_sps,
+                                b_h_pps);
+                        output.writeObject(vdata);
+                        output.flush();
+                        Log.d(TAG, "client: done sending format");
+
+                        break;
+                    }
+                }
+
+                // feeding start
+                boolean isEOS = true;
+
+                ByteBuffer byteBuffer = ByteBuffer.allocate(250000);
+
+                while (isEOS) {
+                    int sampleSize = 0;
+                    try {
+                        sampleSize = mExtractor.readSampleData(byteBuffer, 0);
+                        // Log.d(TAG, j + "  " + byteBuffer.toString());
+                        // byteBuffer.get(to_send);
+                    } catch (IllegalArgumentException e) {
+                        e.printStackTrace();
+                    }
+                    // if (sampleSize < 0) {
+                    // isEOS = false;
+                    // break;
+                    // }
+                    byte[] to_send = new byte[sampleSize];
+
+                    for (int i = 0; i < sampleSize; i++) {
+                        to_send[i] = byteBuffer.get(i);
+                    }
+
+                    // Log.d(TAG, to_send.length + ", " + byteBuffer.limit());
+                    // Log.d(TAG,
+                    // "The sample size is " + String.valueOf(sampleSize));
+                    long presentationTime = mExtractor.getSampleTime();
+
+                    vData vdata = new vData(sampleSize, to_send,
+                            presentationTime);
+                    output.writeObject(vdata);
+                    output.flush();
+//                    Log.d(TAG, "sampleSize at giving " + sampleSize + "");
+                    // if (sampleSize < 0) {
+                    // break;
+                    // } else {
+                    mExtractor.advance();
+                    // }
+                }
+
+                mExtractor.release();
+                socket.close();
+                serverSocket.close();
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+        }
+    }
+    
+    private class mAudioFeeder extends Thread {
+
+        MediaExtractor extractor;
+        AppendingObjectOutputStream oos;
+        private int aport = 4439;
+        String path_url = null;
+
+        mAudioFeeder(FileDescriptor fd, int port) {
+            aport = port;
+             extractor = new MediaExtractor();
+             try {
+             extractor.setDataSource(fd);
+             } catch (IOException e) {
+             // TODO Auto-generated catch block
+             e.printStackTrace();
+             }
+        }
+
+        mAudioFeeder(String path, int port) {
+            aport = port;
+            path_url = path;
+        }
+
+        @Override
+        public void run() {
+            
+            MediaFormat format = null;
+            String mime = "";
+            int sampleRate = 0, channels = 0, bitrate = 0;
+            long duration = 0;
+            ServerSocket serverSocket = null;
+            Log.d(TAG, "You entered Audio Feeder");
+
+            try {
+                serverSocket = new ServerSocket();
+                serverSocket.setReuseAddress(true);
+                serverSocket.bind(new InetSocketAddress(aport));
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+                Log.d(TAG, "File not found!!");
+            }
+
+            // Log.d(TAG, String.valueOf(buffer));
+            // ServerSocket serverSocket;
+            try {
+                // serverSocket = new ServerSocket(aport);
+                Socket socket = serverSocket.accept();
+                // Socket socket = new Socket(InetAddress.getLocalHost(),
+                // aport);
+                Log.d(TAG, "Audio: client has connected");
+
+                OutputStream out = socket.getOutputStream();
+                ObjectOutputStream oo = new ObjectOutputStream(out);
+                InputStream in = socket.getInputStream();
+                ObjectInputStream ois = new ObjectInputStream(in);
+
+                oo.writeUTF("Hello");
+                oo.flush();
+                oos = new AppendingObjectOutputStream(out);
+
+                // format setting
+                try {
+                    format = extractor.getTrackFormat(1);
+                    mime = format.getString(MediaFormat.KEY_MIME);
+                    sampleRate = format.getInteger(MediaFormat.KEY_SAMPLE_RATE);
+                    channels = format.getInteger(MediaFormat.KEY_CHANNEL_COUNT);
+                    // if duration is 0, we are probably playing a live stream
+                    duration = format.getLong(MediaFormat.KEY_DURATION);
+                    // getting csd-0
+                    ByteBuffer header_sps = format.getByteBuffer("csd-0");
+                    byte[] b_h_sps = new byte[header_sps.capacity()];
+                    header_sps.get(b_h_sps);
+
+                    // sending format meta-information from here
+                    SdPackage s = new SdPackage(mime, bitrate, channels,
+                            sampleRate, duration, b_h_sps);
+                    oos.writeObject(s);
+                    oos.flush();
+                } catch (IOException ioe) {
+                    ioe.printStackTrace();
+                }
+
+                Log.d(TAG, "feeder, Audio Track info: " + format.toString());
+                extractor.selectTrack(1);
+
+                ByteBuffer tmp_byteBuffer = ByteBuffer.allocate(2000);
+                int sampleSize = 0;
+                boolean flag = true;
+                while (flag) {
+                    sampleSize = extractor.readSampleData(tmp_byteBuffer, 0);
+
+                    if (sampleSize > 0) {
+                        byte[] to_send = new byte[sampleSize];
+                        for (int i = 0; i < sampleSize; i++) {
+                            to_send[i] = tmp_byteBuffer.get(i);
+                        }
+
+                        long presentationTime = extractor.getSampleTime();
+
+                        SdPackage sdp = new SdPackage(sampleSize, to_send,
+                                presentationTime);
+                        oos.writeObject(sdp);
+                        oos.flush();
+                    }
+                    if (sampleSize < 0) {
+                        flag = false;
+                    } else {
+                        extractor.advance();
+                    }
+                }
+
+                oos.close();
+                socket.close();
+            } catch (IOException e) {
+                // TODO Auto-generated catch block
+                e.printStackTrace();
+            }
+        }
+    }
+
     /**
-     * Prepares the player for playback, synchronously.
-     *
-     * After setting the datasource and the display surface, you need to either
-     * call prepare() or prepareAsync(). For files, it is OK to call prepare(),
-     * which blocks until MediaPlayer is ready for playback.
-     *
+     * Prepares the player for playback, synchronously. After setting the
+     * datasource and the display surface, you need to either call prepare() or
+     * prepareAsync(). For files, it is OK to call prepare(), which blocks until
+     * MediaPlayer is ready for playback.
+     * 
      * @throws IllegalStateException if it is called in an invalid state
      */
     public native void prepare() throws IOException, IllegalStateException;
 
     /**
-     * Prepares the player for playback, asynchronously.
-     *
-     * After setting the datasource and the display surface, you need to either
-     * call prepare() or prepareAsync(). For streams, you should call prepareAsync(),
-     * which returns immediately, rather than blocking until enough data has been
+     * Prepares the player for playback, asynchronously. After setting the
+     * datasource and the display surface, you need to either call prepare() or
+     * prepareAsync(). For streams, you should call prepareAsync(), which
+     * returns immediately, rather than blocking until enough data has been
      * buffered.
-     *
+     * 
      * @throws IllegalStateException if it is called in an invalid state
      */
     public native void prepareAsync() throws IllegalStateException;
 
     /**
      * Starts or resumes playback. If playback had previously been paused,
-     * playback will continue from where it was paused. If playback had
-     * been stopped, or never started before, playback will start at the
-     * beginning.
-     *
+     * playback will continue from where it was paused. If playback had been
+     * stopped, or never started before, playback will start at the beginning.
+     * 
      * @throws IllegalStateException if it is called in an invalid state
      */
-    public  void start() throws IllegalStateException {
+    public void start() throws IllegalStateException {
         stayAwake(true);
+//        Log.d("VideoLatency", "Before _start()");
         _start();
+        Log.d("VideoLatency", "After _start()");
     }
 
     private native void _start() throws IllegalStateException;
 
     /**
      * Stops playback after playback has been stopped or paused.
-     *
+     * 
      * @throws IllegalStateException if the internal player engine has not been
-     * initialized.
+     *             initialized.
      */
     public void stop() throws IllegalStateException {
         stayAwake(false);
         _stop();
+        
     }
 
     private native void _stop() throws IllegalStateException;
 
     /**
      * Pauses playback. Call start() to resume.
-     *
+     * 
      * @throws IllegalStateException if the internal player engine has not been
-     * initialized.
+     *             initialized.
      */
     public void pause() throws IllegalStateException {
         stayAwake(false);
         _pause();
+        
+        Log.d(TAG, "pause.......................");
+        IRemoteService mService = IRemoteService.Stub
+                .asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+            
+            if (isAudio) {
+                ArrayList<Object> para = new ArrayList<Object>();
+                RemoteRequest mRequest = new RemoteRequest("StopMusic",
+                        "Stop", para);
+                
+                try {
+                    mService.sendAllrequest(mRequest);
+                } catch (RemoteException e) {
+                    // TODO Auto-generated catch block
+                    e.printStackTrace();
+                }
+            }
+        
+        
+        Log.d(TAG, "closing all sockets");
+//        closing_all_serversockets();
     }
 
     private native void _pause() throws IllegalStateException;
 
     /**
-     * Set the low-level power management behavior for this MediaPlayer.  This
+     * Set the low-level power management behavior for this MediaPlayer. This
      * can be used when the MediaPlayer is not playing through a SurfaceHolder
      * set with {@link #setDisplay(SurfaceHolder)} and thus can use the
      * high-level {@link #setScreenOnWhilePlaying(boolean)} feature.
-     *
-     * <p>This function has the MediaPlayer access the low-level power manager
+     * <p>
+     * This function has the MediaPlayer access the low-level power manager
      * service to control the device's power usage while playing is occurring.
-     * The parameter is a combination of {@link android.os.PowerManager} wake flags.
-     * Use of this method requires {@link android.Manifest.permission#WAKE_LOCK}
-     * permission.
-     * By default, no attempt is made to keep the device awake during playback.
-     *
+     * The parameter is a combination of {@link android.os.PowerManager} wake
+     * flags. Use of this method requires
+     * {@link android.Manifest.permission#WAKE_LOCK} permission. By default, no
+     * attempt is made to keep the device awake during playback.
+     * 
      * @param context the Context to use
-     * @param mode    the power/wake mode to set
+     * @param mode the power/wake mode to set
      * @see android.os.PowerManager
      */
     public void setWakeMode(Context context, int mode) {
